/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * Laborator 3
 * Programarea in C sub AVR, Comunicatie seriala RS232 si Convertor ADC
 *********************************************************************************/

#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>


/************************************************************************ 
 * REDIRECTARE stdin, stdout pentru receptie, transmisie seriala
 ************************************************************************/
int uart_putchar(char c, FILE *unused);
int uart_getchar(FILE* f);
FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, NULL, _FDEV_SETUP_WRITE);
FILE mystdin =  FDEV_SETUP_STREAM(NULL, uart_getchar, _FDEV_SETUP_READ);


int val;
uint8_t channel = 0;

uint8_t ADC_get(uint8_t channel)
{
	//TODO
	//setati canalul de pe care vreti sa faceti citirea
	ADCSRA &= ~(1<<ADEN);
	ADMUX &= ~31;
	ADMUX |= channel;
	ADCSRA |= (1<<ADIF);	//sterg ADIF
	ADCSRA |= 1 << ADEN;
	ADCSRA |= (1<<ADSC);
	//asteptati sa se termine o conversie
	
	while(ADCSRA & (1 << ADSC)){
		
		;
		
	}
	//returnati rezultatul conversiei
	
	return ADC;
	
}

void ADC_init(void)
{
	//TODO
	//referinta AVCC cu condesator extern pe pinul AREF;
		ADMUX = 1 << REFS0;
		ADMUX &= ~(1 << REFS1);
	// activeaza ADC si il pune in modul free running (auto trigger). Prescaler de ceas la maximum. FARA intrerupere la conversie completa.
		//ADCSRA |= 1 << ADEN;
		//ADCSRA |= 1 << ADSC;
		//ADCSRA |= 1 << ADATE;
		
		ADCSRA |= (7 << ADPS0);
		
		ADCSRA &= ~(1 << ADIE);	//dezactivare intreruperi
		
		
		
}

void USART_init(void)
{
	//TODO
	// Initializare modul USART pt comunicatie la 9600bps, 8 biti de date, la 16MHz	
	
	UCSRB |= 1 << RXEN;
	UCSRB |= 1 << TXEN;
	
	//UCSRC = ;
	UCSRC |= (3 << UCSZ0) |(1 << URSEL);
	
	//UCSRA = 1 << U2X;
	UBRRH = 0;
	UBRRL = 103;
	
	
	
}

void Timer1_init(void)
{
// Initializare timer 1 compare match A pentru a avea un timer la nivel de 1 secunda, 16MHz
	OCR1A = 15624;
	TCCR1A = 0;
	TCCR1B = (1<<WGM12)|(1<<CS12)|(1<<CS10);
	TIMSK |= _BV(OCIE1A);
}



/************************************************************************ 
 * IMPLEMENTARE FUNCTII TRANSMISIE/RECEPTIE SERIALA, pentru mapare stdin, stdout
 ************************************************************************/
// Functie ce trateaza trimiterea unui caracter pe seriala
int uart_putchar(char c, FILE *unused)      
{
	if (c == '\n')
		uart_putchar('\r', 0);
	loop_until_bit_is_set(UCSRA, UDRE);
	UDR = c;
	return 0;
}

// Functie ce trateaza primirea unui caracter pe seriala
int uart_getchar(FILE* f)
{
	char c;
    
    loop_until_bit_is_set(UCSRA, RXC);
    c = UDR;
    if(c=='\r')
		c='\n';
    uart_putchar(c,NULL); 
    return c;
}



